package eduni.inf.nbmodules.pepa.actions;

import eduni.inf.nbmodules.pepa.cookies.SyntaxCheckedCookie;
import java.awt.event.ActionEvent;
import javax.swing.Action;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import org.openide.awt.Actions;
import org.openide.nodes.Node;
import org.openide.util.HelpCtx;
import org.openide.util.NbBundle;
import org.openide.util.actions.CookieAction;
import org.openide.util.actions.SystemAction;
import org.openide.util.actions.Presenter.Menu;
import org.openide.util.actions.Presenter.Popup;





/** Submenu for the various derive actions.
 *
 * @see SilentAction
 * @see CompressedAction
 * @see UnCompressedAction
 *
 * @author N.V.Haenel
 */
public class DeriveMenuAction extends CookieAction implements Menu, Popup {
    
    JMenu menuMenu;
    JMenu popupMenu;
    
    // just an empty menu, so no actions to preform
    public void actionPerformed(ActionEvent ev) { }
    protected void performAction(Node[] node) {}
    
    public String getName() {
        return NbBundle.getMessage(DeriveMenuAction.class, "DeriveMenu_Action");
    }
    
    protected String iconResource() {
        return "eduni/inf/nbmodules/pepa/actions/icons/DeriveActionIcon.gif";
    }
    
    public HelpCtx getHelpCtx() {
        return HelpCtx.DEFAULT_HELP;
    }
    
    public JMenuItem getMenuPresenter() {
        if(menuMenu == null)
            initializeMenu();
        return menuMenu;
        
    }
    
    public JMenuItem getPopupPresenter() {
        if(popupMenu == null)
            initializeMenu();
        
        return popupMenu;
        
    }
    
    
    protected Class[] cookieClasses() {
        return new Class[] {SyntaxCheckedCookie.class };
        
    }
    
    protected int mode() {
        return this.MODE_EXACTLY_ONE;
    }
    
    protected void initializeMenu(){
        JMenuItem menuSilent =  new JMenuItem();
        Actions.connect(menuSilent, (Action)SystemAction.get(SilentAction.class),false);
        JMenuItem menuCompressed = new JMenuItem();
        Actions.connect(menuCompressed, (Action)SystemAction.get(CompressedAction.class),false);                
        JMenuItem menuUncompressed = new JMenuItem();
        Actions.connect(menuUncompressed, (Action)SystemAction.get(UnCompressedAction.class),false);                
        
        
        menuMenu = new JMenu();
        
        menuMenu.add(menuSilent);
        menuMenu.add(menuCompressed);
        menuMenu.add(menuUncompressed);
        
        JMenuItem popupSilent =  new JMenuItem();
        Actions.connect(popupSilent, (Action)SystemAction.get(SilentAction.class),true);
        JMenuItem popupCompressed = new JMenuItem();
        Actions.connect(popupCompressed, (Action)SystemAction.get(CompressedAction.class),true);                
        JMenuItem popupUncompressed = new JMenuItem();
        Actions.connect(popupUncompressed, (Action)SystemAction.get(UnCompressedAction.class),true);                
        
        
        popupMenu = new JMenu();
        
        popupMenu.add(popupSilent);
        popupMenu.add(popupCompressed);
        popupMenu.add(popupUncompressed);
        
        
        Actions.connect(menuMenu, (Action)SystemAction.get(DeriveMenuAction.class), false);
        Actions.connect(popupMenu, (Action)SystemAction.get(DeriveMenuAction.class), true);
    }
}
