package eduni.inf.nbmodules.pepa.actions;


import eduni.inf.nbmodules.pepa.loader.PepaDataObject;


import eduni.inf.pepa.pepa.Peparoni;
import java.awt.BorderLayout;
import java.awt.Component;
import javax.swing.JDialog;

import org.openide.nodes.Node;
import org.openide.util.HelpCtx;
import org.openide.util.NbBundle;
import org.openide.util.actions.CookieAction;
import org.openide.windows.Mode;
import org.openide.windows.TopComponent;
import org.openide.windows.WindowManager;


/** Action to invoke external dialogs used by the PEPA Workbench.
 *
 * <p>
 * This action serves as a way to include <code>JDialog</code>s as 
 * <code>TopComponents</code> that dock into the editor. Essentially
 * the <code>JDialog</code>s content pane is added to
 * <code>JDialogContainer</code>.
 * 
 * </p>
 *
 *
 * @see TopComponent
 * @see JDialog
 * 
 *
 * @author N.V.Haenel
 */
public abstract class InvokeDialogAction extends CookieAction {
    
    
    protected int mode() {
        return MODE_EXACTLY_ONE;
        // return MODE_ALL;
    }
    
    protected void performAction(Node[] nodes) {
        PepaDataObject obj = (PepaDataObject)nodes[0].getCookie(PepaDataObject.class);
        // only when state space established, no need o check for
        JDialog dialog = this.getDialog(obj.getPeparoni());
        TopComponent dialogContainer = new JDialogContainer(dialog.getContentPane(),this.getLabel() ,obj.getName());
        Mode mode = WindowManager.getDefault().findMode("output");
        if (mode != null) {
            mode.dockInto(dialogContainer );
        } else {
        }
        obj.addDialog(dialogContainer);
        
        dialogContainer.open();
        dialogContainer.requestActive();
        
    }
    public String getName() {
        return NbBundle.getMessage(PepaStateFinderAction.class, "SingleStepDebuggerAction");
    }
    
    protected String iconResource() {
        return null;
        //return "eduni/inf/nbmodules/pepa/actions/SolveActionIcon.gif";
    }
    
    public HelpCtx getHelpCtx() {
        return HelpCtx.DEFAULT_HELP;
    }
    
    protected boolean asynchronous() {
        return true;
    }
    /** Implement this to get the dialog to diaply */
    protected abstract JDialog getDialog(Peparoni p);
    
    /** Implement this to get the display name of the dialog */    
    protected abstract String getLabel();
    
    /** Containers for the JDialogs content frame*/
    public static class JDialogContainer extends TopComponent {
        public JDialogContainer (Component c,String label, String filename){
             setName(label+" "+filename);
             setLayout(new BorderLayout());             
             this.add(c);             
        }
    }
    
    
    
}
