package eduni.inf.nbmodules.pepa.actions;

import eduni.inf.nbmodules.pepa.settings.LnbcgSettings;
import eduni.inf.pepa.pepa.Peparoni;
import java.util.Vector;
import org.openide.ErrorManager;
import org.openide.options.SystemOption;
import org.openide.util.NbBundle;

/** Action to solve the PEPA model using Linear Biconjugate Gradient method.
 *
 * @author N.V.Haenel
 */
public class LnbcgSolveAction extends SolveAction {
            
    protected boolean executeSolver(Peparoni driver){
        try{
            // get settings
            LnbcgSettings ls = (LnbcgSettings)SystemOption.findObject(LnbcgSettings.class, true);        
	    Vector vector = new Vector(4);        
            vector.addElement(new Integer(ls.getItol()));
            vector.addElement(new Integer(ls.getMaxiters()));
            vector.addElement(new Double(ls.getTolerance()));
            vector.addElement(new Boolean(ls.isGmres()));        
            driver.setSolParam(vector);
            // solve
            driver.solve();
            return true;
        }catch(Exception e){
            ErrorManager.getDefault().notify(ErrorManager.EXCEPTION, e);        
            return false;
        }
    }
    
    public String getName() {
        return NbBundle.getMessage(LnbcgSolveAction.class, "LnbcgSolve_Action");
    }
    
    protected String iconResource() {
        return "eduni/inf/nbmodules/pepa/actions/icons/LnbcgActionIcon.gif";
    }   
}
