package eduni.inf.nbmodules.pepa.actions;

import eduni.inf.pepa.workbench.Reporter;
import java.io.IOException;
import org.openide.ErrorManager;
import org.openide.windows.IOProvider;
import org.openide.windows.InputOutput;
import org.openide.windows.OutputWriter;

/** Provides the IO Tab for PEPA
 *
 * @author N.V.Haenel
 */
public  class PepaIOProvider{
    
    private static InputOutput io;
    
    static {
        io = IOProvider.getDefault().getIO("PEPA", false);
        Reporter.get().setExternalMode(true);        
    }
    
    public static OutputWriter getOutputWriter(){
        Reporter.get().setPrintWriter(io.getOut());
        io.setFocusTaken(true);
        io.select();
        try{
            io.getOut().reset();
        }catch(IOException ioe){
            ErrorManager.getDefault().notify(ErrorManager.EXCEPTION, ioe);
        }
        return io.getOut();
    }        
}