package eduni.inf.nbmodules.pepa.actions;

import eduni.inf.nbmodules.pepa.cookies.StateSpaceCookie;
import java.awt.event.ActionEvent;
import javax.swing.Action;
import javax.swing.JMenu;
import javax.swing.JMenuItem;

import org.openide.awt.Actions;
import org.openide.nodes.Node;
import org.openide.util.HelpCtx;
import org.openide.util.NbBundle;
import org.openide.util.actions.CookieAction;
import org.openide.util.actions.SystemAction;
import org.openide.util.actions.Presenter.Menu;
import org.openide.util.actions.Presenter.Popup;





/** Submenu for the various Solve actions.
 *
 * @see LnbcgSolveAction
 * @see SorSolveAction
 *  
 * @author N.V.Haenel
 */
public class SolveMenuAction extends CookieAction implements Menu, Popup {
    
    JMenu menuMenu;
    JMenu popupMenu;
    
    public void actionPerformed(ActionEvent ev) { }
    
    protected void performAction(Node[] node) {}
    
    
    public String getName() {
        return NbBundle.getMessage(DeriveMenuAction.class, "SolveMenu_Action");
    }
    
    protected String iconResource() {
        return "eduni/inf/nbmodules/pepa/actions/icons/SolveActionIcon.gif";
    }
    
    public HelpCtx getHelpCtx() {
        return HelpCtx.DEFAULT_HELP;
        // If you will provide context help then use:
        // return new HelpCtx(DeriveMenuAction.class);
    }
        
    public JMenuItem getMenuPresenter() {
        if(menuMenu == null)
            initializeMenu();
        return menuMenu;
    }
    
    public JMenuItem getPopupPresenter() {
        if(menuMenu == null)
            initializeMenu();
        return popupMenu;
        
    }
    
    protected Class[] cookieClasses() {
        return new Class[] {StateSpaceCookie.class };

    }
    
    protected int mode() {
        return this.MODE_EXACTLY_ONE;
    }
    
    protected void initializeMenu(){
        JMenuItem menuLnbcg =  new JMenuItem();
        
        
        
        Actions.connect(menuLnbcg, (Action)SystemAction.get(LnbcgSolveAction.class), false);                        
        JMenuItem menuSor = new JMenuItem();
        Actions.connect(menuSor, (Action)SystemAction.get(SorSolveAction.class), false);        
                        
        menuMenu = new JMenu();        
        menuMenu.add(menuLnbcg);
        menuMenu.add(menuSor);
        
        Actions.connect(menuMenu, (Action)SystemAction.get(SolveMenuAction.class), false);        
        
        JMenuItem popupLnbcg =  new JMenuItem();
        Actions.connect(popupLnbcg, (Action)SystemAction.get(LnbcgSolveAction.class), true);                        
        JMenuItem popupSor = new JMenuItem();
        Actions.connect(popupSor, (Action)SystemAction.get(SorSolveAction.class), true);        
                        
        popupMenu = new JMenu();        
        popupMenu.add(popupLnbcg);
        popupMenu.add(popupSor);
        
        Actions.connect(popupMenu, (Action)SystemAction.get(SolveMenuAction.class), true);        
                                                
    }
}
