package eduni.inf.nbmodules.pepa.actions;

import eduni.inf.nbmodules.pepa.settings.SorSettings;
import eduni.inf.pepa.pepa.Peparoni;
import java.util.Vector;
import org.openide.ErrorManager;
import org.openide.options.SystemOption;
import org.openide.util.NbBundle;

/** Action to solve the PEPA model using Successive Over Relaxation.
 *
 * @author N.V.Haenel
 */
public class SorSolveAction extends SolveAction {
    
    protected boolean executeSolver(Peparoni driver){
        try{
            SorSettings ss = (SorSettings)SystemOption.findObject(SorSettings.class, true);        	    
            Vector vector = new Vector(4);
            vector.addElement(new Double(ss.getOmega()));
            vector.addElement(new Integer(ss.getMaxiters()));
            vector.addElement(new Double(ss.getTolerance()));
            vector.addElement(new Integer(ss.getNorm()));
            driver.setSorParam(vector);
            driver.SORsolve();
            return true;
        }catch(Exception e){
            ErrorManager.getDefault().notify(ErrorManager.EXCEPTION, e);
        }
        return false;
    }
    
    public String getName() {
        return NbBundle.getMessage(SorSolveAction.class, "SorSolve_Action");
    }
    
    protected String iconResource() {
        return "eduni/inf/nbmodules/pepa/actions/icons/SorActionIcon.gif";
    }
}
