/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package eduni.inf.nbmodules.pepa.editor;

import org.netbeans.modules.editor.options.PlainOptions;
import org.openide.util.HelpCtx;


/**
* Options for PEPA editor kit, <code>{@link PepaKit}</code>.
*
* @author N.V.Haenel
*/
public class PepaOptions extends PlainOptions {

    public static final String PEPA = "pepa"; // NOI18N
        
    public PepaOptions() {
        this(PepaKit.class, PEPA);             
    }
    public PepaOptions(Class kitClass, String typeName) {
        super(kitClass, typeName);
    }
    public HelpCtx getHelpCtx () {
        return HelpCtx.DEFAULT_HELP;
    }    
    public String displayName() {
        // should get the display Name from a Bundle
        return "PEPA Editor";
    }        
    
}
