/* Generated By:JavaCC: Do not edit this line. PepaParser.java */
                         // 


package eduni.inf.nbmodules.pepa.editor.parser;

import eduni.inf.pepa.pepamodel.*;
import eduni.inf.pepa.pepamodel.other.*;
import eduni.inf.pepa.pepamodel.process.*;
import eduni.inf.pepa.pepamodel.rate.*;
import eduni.inf.pepa.pepamodel.visitors.*;
import java.util.*;


import java.util.ArrayList;
import java.util.List;

public class PepaParser implements PepaParserConstants {

    /**the PEPA model*/
  private PepaModel model;
  private List parseExceptions;

  public static void main(String args[]) {
    PepaParser parser;
    java.io.InputStream input;

    if (args.length==1) {
      System.out.println(args[args.length-1] + ": ");
      try {
        input = new java.io.FileInputStream(args[args.length-1]);
      } catch (java.io.FileNotFoundException e) {
        System.out.println("File not found.");
        return;
      }
    } else if (args.length==0) {
      System.out.println("Reading from standard input...");
      input = System.in;
    } else {
      System.out.println("Usage: java PepaParser [inputfile]");
      return;
    }
      parser = new PepaParser(input);
      parser.parse();
      System.out.println(parser.getModel());
  }

  /**Convenience constructor.
   *
   * The arguments have non-standard descriptors
   * so that references can be passed to the constructor
   * as multiple return types are required
   *
   * @param i the input stream to read from
   * @param m reference to the model, will be the parsed model
   * @param e any parsing excptions encountered during the parse
   * @param s dictates if the parse was successfull
   */
  public PepaParser(java.io.InputStream i, PepaModel m, List e, boolean s ){
        this(i);
        this.parse();
        m = this.getModel();
        e = this.getParseExceptions();
        s = !parseExceptions.isEmpty();
  }

  public PepaModel getModel(){
      return this.model;
  }

  public List getParseExceptions(){
       return this.parseExceptions;
  }

  public boolean parse() {
      this.model = new PepaModel();
      this.parseExceptions = new ArrayList();
      try{
          this.model_unit();
      }catch(ParseException e){
          parseExceptions.add(e);
      }
      return true;
  }




  void printExceptions(){
    for(Iterator i = parseExceptions.iterator();i.hasNext();){
        System.out.println(((ParseException)i.next()).getMessage());
    }
  }

//LEXER END HERE
//-----------------------------------------------------------------------------
//PARSER STARTS HERE
  final public void model_unit() throws ParseException {
    rate_declarartion_list();
    process_definition_list();
    system_equation();
    jj_consume_token(0);
  }

  final public void rate_declarartion_list() throws ParseException {
    label_1:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ACTION_IDENTIFIER:
        ;
        break;
      default:
        jj_la1[0] = jj_gen;
        break label_1;
      }
      rate_declaration();
    }
  }

  final public void process_definition_list() throws ParseException {
    label_2:
    while (true) {
      process_declaration();
      if (jj_2_1(2)) {
        ;
      } else {
        break label_2;
      }
    }
  }

  final public void system_equation() throws ParseException {
    PepaProcess p;
    try {
      p = pepa_composition();
                            model.setSystemEquation(p);
    } catch (ParseException e) {
        error_skipto(SEMI,e);
    }
  }

  final public void rate_declaration() throws ParseException {
    Token t;
    PepaRate r;
    try {
      t = jj_consume_token(ACTION_IDENTIFIER);
      jj_consume_token(EQUALS);
      r = rate_sum();
      jj_consume_token(SEMI);
      model.addRate(new PepaSpecifiedRate(t.image,r));
    } catch (ParseException e) {
        error_skipto(SEMI, e);
    }
  }

  final public PepaRate rate_sum() throws ParseException {
  PepaRate p1;
  PepaRate p2 =null;
  Token p = null;
    p1 = rate_product();
    label_3:
    while (true) {
      if (jj_2_2(2)) {
        ;
      } else {
        break label_3;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case PLUS:
        p = jj_consume_token(PLUS);
        break;
      case MINUS:
        jj_consume_token(MINUS);
        break;
      default:
        jj_la1[1] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      p2 = rate_sum();
    }
     {if (true) return (p2==null ? p1 : new PepaRateExpression(p1,p2,p!=null?"+":"-"));}
    throw new Error("Missing return statement in function");
  }

  final public PepaRate rate_product() throws ParseException {
  PepaRate p1;
  PepaRate p2= null;
  Token m = null;
    p1 = rate_term();
    label_4:
    while (true) {
      if (jj_2_3(2)) {
        ;
      } else {
        break label_4;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case MUL:
        m = jj_consume_token(MUL);
        break;
      case DIV:
        jj_consume_token(DIV);
        break;
      default:
        jj_la1[2] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      p2 = rate_product();
    }
      {if (true) return (p2==null ? p1 : new PepaRateExpression(p1,p2,m!=null?"*":"/"));}
    throw new Error("Missing return statement in function");
  }

  final public PepaRate rate_term() throws ParseException {
  PepaRate r = null;
  Token t;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LPAREN:
      jj_consume_token(LPAREN);
      r = rate_sum();
      jj_consume_token(RPAREN);
                                      {if (true) return r;}
      break;
    case NUMBER:
      t = jj_consume_token(NUMBER);
                                      {if (true) return new PepaNumericRate(Double.parseDouble(t.image));}
      break;
    case ACTION_IDENTIFIER:
      t = jj_consume_token(ACTION_IDENTIFIER);
                                        if( (r = model.containsRate(t.image))!=null){
                                            {if (true) return r;}
                                        }
                                        else
                                            {if (true) return new PepaUndefinedRate(t.image);}
      break;
    case INFTY:
    case TOP:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case INFTY:
        jj_consume_token(INFTY);
        break;
      case TOP:
        jj_consume_token(TOP);
        break;
      default:
        jj_la1[3] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
                                      {if (true) return PepaTopRate.getTop();}
      break;
    default:
      jj_la1[4] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

  final public void process_declaration() throws ParseException {
    Token t;
    PepaProcess p;
    try {
      t = jj_consume_token(PROCESS_IDENTIFIER);
      jj_consume_token(EQUALS);
      p = pepa_composition();
      jj_consume_token(SEMI);
      model.addDefinition(new PepaDefinition(new PepaVariable(t.image),p));
    } catch (ParseException e) {
        error_skipto(SEMI, e);
    }
  }

  final public PepaProcess pepa_composition() throws ParseException {
    PepaProcess p1;
    PepaProcess p2 = null;
    Token t =null;
    ActionSet s = new ActionSet();
    // bit tricky, careful
        // needed this to get the cooperation object
    
        p1 = pepa_choice();
    label_5:
    while (true) {
      if (jj_2_4(2)) {
        ;
      } else {
        break label_5;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LESS:
        jj_consume_token(LESS);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case LBRACE:
        case ACTION_IDENTIFIER:
          s = action_set();
          break;
        default:
          jj_la1[5] = jj_gen;
          ;
        }
        jj_consume_token(GREATER);
        break;
      case SEQCOMP:
        jj_consume_token(SEQCOMP);
        break;
      default:
        jj_la1[6] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      p2 = pepa_composition();
    }
      {if (true) return p2==null?p1: new PepaCooperation(p1,p2,s);}
    throw new Error("Missing return statement in function");
  }

  final public PepaProcess pepa_choice() throws ParseException {
    Token action;
    PepaRate rate;
    PepaProcess p;
    List l = null;
    p = pepa_prefix();
    label_6:
    while (true) {
      if (jj_2_5(2)) {
        ;
      } else {
        break label_6;
      }
      jj_consume_token(PLUS);
      l = pepa_choice_list();
    }
     if (l ==null) {if (true) return p;}
     else { l.add(p);  {if (true) return new PepaChoice(l);}}
    throw new Error("Missing return statement in function");
  }

  final public List pepa_choice_list() throws ParseException {
    PepaProcess p;
    List l =null;
    p = pepa_prefix();
    if (jj_2_6(2)) {
      jj_consume_token(PLUS);
      l = pepa_choice_list();
    } else {
      ;
    }
      if (l==null){
        l = new ArrayList();
        l.add(p);
        {if (true) return l;}
      }
      else{
        l.add(p);
        {if (true) return l;}
      }
    throw new Error("Missing return statement in function");
  }

  final public PepaProcess pepa_prefix() throws ParseException {
    Token action;
    PepaRate rate;
    PepaProcess p;
    if (jj_2_7(2)) {
      p = pepa_hide();
                     {if (true) return p;}
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LPAREN:
        jj_consume_token(LPAREN);
        action = jj_consume_token(ACTION_IDENTIFIER);
        jj_consume_token(COMMA);
        rate = rate_sum();
        jj_consume_token(RPAREN);
        jj_consume_token(PREFIX);
        p = pepa_prefix();
        PepaAction a = new PepaAction(action.image);
        {if (true) return new PepaPrefix(new PepaActivity(a,rate), p);}
        break;
      default:
        jj_la1[7] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
    throw new Error("Missing return statement in function");
  }

  final public PepaProcess pepa_hide() throws ParseException {
    PepaProcess p;
    Token d = null;
    ActionSet s = null;
    p = pepa_variable();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case DIV:
      d = jj_consume_token(DIV);
      s = action_set();
      break;
    default:
      jj_la1[8] = jj_gen;
      ;
    }
       {if (true) return d==null?p:new PepaHide(p, s);}
    throw new Error("Missing return statement in function");
  }

  final public PepaProcess pepa_variable() throws ParseException {
    PepaProcess p;
    Token t;
    if (jj_2_8(2)) {
      jj_consume_token(LPAREN);
      p = pepa_composition();
      jj_consume_token(RPAREN);
                                             {if (true) return p;}
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case PROCESS_IDENTIFIER:
        t = jj_consume_token(PROCESS_IDENTIFIER);
                              {if (true) return new PepaVariable(t.image);}
        break;
      default:
        jj_la1[9] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
    throw new Error("Missing return statement in function");
  }

  final public ActionSet action_set() throws ParseException {
    ActionSet s;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LBRACE:
      jj_consume_token(LBRACE);
      s = action_list();
      jj_consume_token(RBRACE);
                                      {if (true) return s;}
      break;
    case ACTION_IDENTIFIER:
      s = action_list();
                     {if (true) return s;}
      break;
    default:
      jj_la1[10] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

  final public ActionSet action_list() throws ParseException {
    Token t;
    ActionSet s;
    if (jj_2_10(2)) {
      t = jj_consume_token(ACTION_IDENTIFIER);
      label_7:
      while (true) {
        jj_consume_token(COMMA);
        s = action_list();
        if (jj_2_9(2)) {
          ;
        } else {
          break label_7;
        }
      }
     s.add(new PepaAction(t.image));  {if (true) return s;}
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ACTION_IDENTIFIER:
        t = jj_consume_token(ACTION_IDENTIFIER);
     s = new ActionSet(); s.add(new PepaAction(t.image)); {if (true) return s;}
        break;
      default:
        jj_la1[11] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
    throw new Error("Missing return statement in function");
  }

  void error_skipto(int kind, ParseException e) throws ParseException {
  parseExceptions.add(e);  // generate the exception object.  
  Token t;
  do {
    t = getNextToken();
  } while (t.kind != kind && t.kind != EOF);
  }

  final private boolean jj_2_1(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_1(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(0, xla); }
  }

  final private boolean jj_2_2(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_2(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(1, xla); }
  }

  final private boolean jj_2_3(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_3(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(2, xla); }
  }

  final private boolean jj_2_4(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_4(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(3, xla); }
  }

  final private boolean jj_2_5(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_5(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(4, xla); }
  }

  final private boolean jj_2_6(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_6(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(5, xla); }
  }

  final private boolean jj_2_7(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_7(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(6, xla); }
  }

  final private boolean jj_2_8(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_8(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(7, xla); }
  }

  final private boolean jj_2_9(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_9(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(8, xla); }
  }

  final private boolean jj_2_10(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_10(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(9, xla); }
  }

  final private boolean jj_3_3() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(17)) {
    jj_scanpos = xsp;
    if (jj_scan_token(18)) return true;
    }
    if (jj_3R_10()) return true;
    return false;
  }

  final private boolean jj_3R_25() {
    if (jj_scan_token(ACTION_IDENTIFIER)) return true;
    return false;
  }

  final private boolean jj_3R_14() {
    if (jj_3R_20()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_21()) jj_scanpos = xsp;
    return false;
  }

  final private boolean jj_3R_24() {
    if (jj_scan_token(NUMBER)) return true;
    return false;
  }

  final private boolean jj_3R_18() {
    if (jj_3R_19()) return true;
    return false;
  }

  final private boolean jj_3_2() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(15)) {
    jj_scanpos = xsp;
    if (jj_scan_token(16)) return true;
    }
    if (jj_3R_9()) return true;
    return false;
  }

  final private boolean jj_3R_23() {
    if (jj_scan_token(LPAREN)) return true;
    return false;
  }

  final private boolean jj_3R_16() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_23()) {
    jj_scanpos = xsp;
    if (jj_3R_24()) {
    jj_scanpos = xsp;
    if (jj_3R_25()) {
    jj_scanpos = xsp;
    if (jj_3R_26()) return true;
    }
    }
    }
    return false;
  }

  final private boolean jj_3R_22() {
    if (jj_scan_token(ACTION_IDENTIFIER)) return true;
    return false;
  }

  final private boolean jj_3R_12() {
    if (jj_3R_18()) return true;
    return false;
  }

  final private boolean jj_3R_28() {
    if (jj_scan_token(LPAREN)) return true;
    return false;
  }

  final private boolean jj_3R_10() {
    if (jj_3R_16()) return true;
    return false;
  }

  final private boolean jj_3R_17() {
    if (jj_3R_27()) return true;
    return false;
  }

  final private boolean jj_3R_15() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_10()) {
    jj_scanpos = xsp;
    if (jj_3R_22()) return true;
    }
    return false;
  }

  final private boolean jj_3_1() {
    if (jj_3R_8()) return true;
    return false;
  }

  final private boolean jj_3_10() {
    if (jj_scan_token(ACTION_IDENTIFIER)) return true;
    Token xsp;
    if (jj_3_9()) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_9()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_19() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_7()) {
    jj_scanpos = xsp;
    if (jj_3R_28()) return true;
    }
    return false;
  }

  final private boolean jj_3_7() {
    if (jj_3R_14()) return true;
    return false;
  }

  final private boolean jj_3_6() {
    if (jj_scan_token(PLUS)) return true;
    if (jj_3R_13()) return true;
    return false;
  }

  final private boolean jj_3R_31() {
    if (jj_3R_15()) return true;
    return false;
  }

  final private boolean jj_3R_21() {
    if (jj_scan_token(DIV)) return true;
    return false;
  }

  final private boolean jj_3R_11() {
    if (jj_scan_token(LESS)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_17()) jj_scanpos = xsp;
    if (jj_scan_token(GREATER)) return true;
    return false;
  }

  final private boolean jj_3R_9() {
    if (jj_3R_10()) return true;
    return false;
  }

  final private boolean jj_3R_30() {
    if (jj_scan_token(LBRACE)) return true;
    return false;
  }

  final private boolean jj_3R_27() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_30()) {
    jj_scanpos = xsp;
    if (jj_3R_31()) return true;
    }
    return false;
  }

  final private boolean jj_3_5() {
    if (jj_scan_token(PLUS)) return true;
    if (jj_3R_13()) return true;
    return false;
  }

  final private boolean jj_3R_8() {
    if (jj_scan_token(PROCESS_IDENTIFIER)) return true;
    if (jj_scan_token(EQUALS)) return true;
    return false;
  }

  final private boolean jj_3R_29() {
    if (jj_scan_token(PROCESS_IDENTIFIER)) return true;
    return false;
  }

  final private boolean jj_3R_20() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_8()) {
    jj_scanpos = xsp;
    if (jj_3R_29()) return true;
    }
    return false;
  }

  final private boolean jj_3R_13() {
    if (jj_3R_19()) return true;
    return false;
  }

  final private boolean jj_3_8() {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_12()) return true;
    return false;
  }

  final private boolean jj_3_4() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_11()) {
    jj_scanpos = xsp;
    if (jj_scan_token(25)) return true;
    }
    if (jj_3R_12()) return true;
    return false;
  }

  final private boolean jj_3_9() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_3R_15()) return true;
    return false;
  }

  final private boolean jj_3R_26() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(10)) {
    jj_scanpos = xsp;
    if (jj_scan_token(11)) return true;
    }
    return false;
  }

  public PepaParserTokenManager token_source;
  SimpleCharStream jj_input_stream;
  public Token token, jj_nt;
  private int jj_ntk;
  private Token jj_scanpos, jj_lastpos;
  private int jj_la;
  public boolean lookingAhead = false;
  private boolean jj_semLA;
  private int jj_gen;
  final private int[] jj_la1 = new int[12];
  static private int[] jj_la1_0;
  static private int[] jj_la1_1;
  static {
      jj_la1_0();
      jj_la1_1();
   }
   private static void jj_la1_0() {
      jj_la1_0 = new int[] {0x0,0x18000,0x60000,0xc00,0x8000c00,0x20000000,0x2080000,0x8000000,0x40000,0x0,0x20000000,0x0,};
   }
   private static void jj_la1_1() {
      jj_la1_1 = new int[] {0x200,0x0,0x0,0x0,0x210,0x200,0x0,0x0,0x0,0x100,0x200,0x200,};
   }
  final private JJCalls[] jj_2_rtns = new JJCalls[10];
  private boolean jj_rescan = false;
  private int jj_gc = 0;

  public PepaParser(java.io.InputStream stream) {
    jj_input_stream = new SimpleCharStream(stream, 1, 1);
    token_source = new PepaParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 12; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public void ReInit(java.io.InputStream stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 12; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public PepaParser(java.io.Reader stream) {
    jj_input_stream = new SimpleCharStream(stream, 1, 1);
    token_source = new PepaParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 12; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public void ReInit(java.io.Reader stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 12; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public PepaParser(PepaParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 12; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public void ReInit(PepaParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 12; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  final private Token jj_consume_token(int kind) throws ParseException {
    Token oldToken;
    if ((oldToken = token).next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    if (token.kind == kind) {
      jj_gen++;
      if (++jj_gc > 100) {
        jj_gc = 0;
        for (int i = 0; i < jj_2_rtns.length; i++) {
          JJCalls c = jj_2_rtns[i];
          while (c != null) {
            if (c.gen < jj_gen) c.first = null;
            c = c.next;
          }
        }
      }
      return token;
    }
    token = oldToken;
    jj_kind = kind;
    throw generateParseException();
  }

  static private final class LookaheadSuccess extends java.lang.Error { }
  final private LookaheadSuccess jj_ls = new LookaheadSuccess();
  final private boolean jj_scan_token(int kind) {
    if (jj_scanpos == jj_lastpos) {
      jj_la--;
      if (jj_scanpos.next == null) {
        jj_lastpos = jj_scanpos = jj_scanpos.next = token_source.getNextToken();
      } else {
        jj_lastpos = jj_scanpos = jj_scanpos.next;
      }
    } else {
      jj_scanpos = jj_scanpos.next;
    }
    if (jj_rescan) {
      int i = 0; Token tok = token;
      while (tok != null && tok != jj_scanpos) { i++; tok = tok.next; }
      if (tok != null) jj_add_error_token(kind, i);
    }
    if (jj_scanpos.kind != kind) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) throw jj_ls;
    return false;
  }

  final public Token getNextToken() {
    if (token.next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    jj_gen++;
    return token;
  }

  final public Token getToken(int index) {
    Token t = lookingAhead ? jj_scanpos : token;
    for (int i = 0; i < index; i++) {
      if (t.next != null) t = t.next;
      else t = t.next = token_source.getNextToken();
    }
    return t;
  }

  final private int jj_ntk() {
    if ((jj_nt=token.next) == null)
      return (jj_ntk = (token.next=token_source.getNextToken()).kind);
    else
      return (jj_ntk = jj_nt.kind);
  }

  private java.util.Vector jj_expentries = new java.util.Vector();
  private int[] jj_expentry;
  private int jj_kind = -1;
  private int[] jj_lasttokens = new int[100];
  private int jj_endpos;

  private void jj_add_error_token(int kind, int pos) {
    if (pos >= 100) return;
    if (pos == jj_endpos + 1) {
      jj_lasttokens[jj_endpos++] = kind;
    } else if (jj_endpos != 0) {
      jj_expentry = new int[jj_endpos];
      for (int i = 0; i < jj_endpos; i++) {
        jj_expentry[i] = jj_lasttokens[i];
      }
      boolean exists = false;
      for (java.util.Enumeration e = jj_expentries.elements(); e.hasMoreElements();) {
        int[] oldentry = (int[])(e.nextElement());
        if (oldentry.length == jj_expentry.length) {
          exists = true;
          for (int i = 0; i < jj_expentry.length; i++) {
            if (oldentry[i] != jj_expentry[i]) {
              exists = false;
              break;
            }
          }
          if (exists) break;
        }
      }
      if (!exists) jj_expentries.addElement(jj_expentry);
      if (pos != 0) jj_lasttokens[(jj_endpos = pos) - 1] = kind;
    }
  }

  public ParseException generateParseException() {
    jj_expentries.removeAllElements();
    boolean[] la1tokens = new boolean[48];
    for (int i = 0; i < 48; i++) {
      la1tokens[i] = false;
    }
    if (jj_kind >= 0) {
      la1tokens[jj_kind] = true;
      jj_kind = -1;
    }
    for (int i = 0; i < 12; i++) {
      if (jj_la1[i] == jj_gen) {
        for (int j = 0; j < 32; j++) {
          if ((jj_la1_0[i] & (1<<j)) != 0) {
            la1tokens[j] = true;
          }
          if ((jj_la1_1[i] & (1<<j)) != 0) {
            la1tokens[32+j] = true;
          }
        }
      }
    }
    for (int i = 0; i < 48; i++) {
      if (la1tokens[i]) {
        jj_expentry = new int[1];
        jj_expentry[0] = i;
        jj_expentries.addElement(jj_expentry);
      }
    }
    jj_endpos = 0;
    jj_rescan_token();
    jj_add_error_token(0, 0);
    int[][] exptokseq = new int[jj_expentries.size()][];
    for (int i = 0; i < jj_expentries.size(); i++) {
      exptokseq[i] = (int[])jj_expentries.elementAt(i);
    }
    return new ParseException(token, exptokseq, tokenImage);
  }

  final public void enable_tracing() {
  }

  final public void disable_tracing() {
  }

  final private void jj_rescan_token() {
    jj_rescan = true;
    for (int i = 0; i < 10; i++) {
      JJCalls p = jj_2_rtns[i];
      do {
        if (p.gen > jj_gen) {
          jj_la = p.arg; jj_lastpos = jj_scanpos = p.first;
          switch (i) {
            case 0: jj_3_1(); break;
            case 1: jj_3_2(); break;
            case 2: jj_3_3(); break;
            case 3: jj_3_4(); break;
            case 4: jj_3_5(); break;
            case 5: jj_3_6(); break;
            case 6: jj_3_7(); break;
            case 7: jj_3_8(); break;
            case 8: jj_3_9(); break;
            case 9: jj_3_10(); break;
          }
        }
        p = p.next;
      } while (p != null);
    }
    jj_rescan = false;
  }

  final private void jj_save(int index, int xla) {
    JJCalls p = jj_2_rtns[index];
    while (p.gen > jj_gen) {
      if (p.next == null) { p = p.next = new JJCalls(); break; }
      p = p.next;
    }
    p.gen = jj_gen + xla - jj_la; p.first = token; p.arg = xla;
  }

  static final class JJCalls {
    int gen;
    Token first;
    int arg;
    JJCalls next;
  }

}
