package eduni.inf.nbmodules.pepa.settings;

import java.awt.Image;
import java.beans.*;

import org.openide.ErrorManager;
import org.openide.util.NbBundle;
import org.openide.util.Utilities;

/** Description of {@link LnbcgSettings}.
 *
 * @author N.V.Haenel
 */
public class LnbcgSettingsBeanInfo extends SimpleBeanInfo {
    
    public PropertyDescriptor[] getPropertyDescriptors() {
        try {
            
            PropertyDescriptor itol = new PropertyDescriptor("itol", LnbcgSettings.class);
            itol.setDisplayName(NbBundle.getMessage(LnbcgSettingsBeanInfo.class, "PROP_itol"));
            itol.setShortDescription(NbBundle.getMessage(LnbcgSettingsBeanInfo.class, "HINT_itol"));
            itol.setPropertyEditorClass(ItolEditor.class);

            
            PropertyDescriptor maxiters = new PropertyDescriptor("maxiters", LnbcgSettings.class);
            maxiters.setDisplayName(NbBundle.getMessage(LnbcgSettingsBeanInfo.class, "PROP_maxiters"));
            maxiters.setShortDescription(NbBundle.getMessage(LnbcgSettingsBeanInfo.class, "HINT_maxiters"));
            
            PropertyDescriptor tolerance = new PropertyDescriptor("tolerance", LnbcgSettings.class);
            tolerance.setDisplayName(NbBundle.getMessage(LnbcgSettingsBeanInfo.class, "PROP_tolerance"));
            tolerance.setShortDescription(NbBundle.getMessage(LnbcgSettingsBeanInfo.class, "HINT_tolerance"));
            
            PropertyDescriptor gmres = new PropertyDescriptor("gmres", LnbcgSettings.class);
            gmres.setDisplayName(NbBundle.getMessage(LnbcgSettingsBeanInfo.class, "PROP_gmres"));
            gmres.setShortDescription(NbBundle.getMessage(LnbcgSettingsBeanInfo.class, "HINT_gmres"));
            
            
            
            
            
            return new PropertyDescriptor[] {itol,maxiters,tolerance,gmres};
        } catch (IntrospectionException ie) {
            ErrorManager.getDefault().notify(ie);
            return null;
        }
    }
    
    
    
    public static class ItolEditor extends PropertyEditorSupport {
        
        private static final String[] tags = {"1","2","3","4"};
        
        private static final int[] levels = {1,2,3,4};
        
        public String[] getTags() {  return tags;    }
                
        public String getAsText () {
            int l = ((Integer) getValue ()).intValue ();
            for (int i = 0; i < levels.length; i++) {
                if (l == levels[i]) {
                    return tags[i];
                }
            }
            return "???"; // NOI18N
        }

        public void setAsText (String text) throws IllegalArgumentException {
            for (int i = 0; i < tags.length; i++) {
                if (tags[i].equals (text)) {
                    setValue (new Integer (levels[i]));
                    return;
                }
            }
            throw new IllegalArgumentException ();
        }                
    }    
}
