package eduni.inf.nbmodules.pepa.settings;

import eduni.inf.pepa.workbench.Reporter;
import org.openide.options.SystemOption;
import org.openide.util.HelpCtx;
import org.openide.util.NbBundle;

/** Options for PEPA module.
 *
 * @author N.V.Haenel
 */
public class PepaSettings extends SystemOption {
    
    private static final long serialVersionUID = 1L;
    
    private static final String PROP_SOLVER = "solver";
    private static final String PROP_OUTPUT = "output";
    private static final String PROP_BACKGRND = "backgrnd";
    private static final String PROP_BGRNDTIME = "bgrndtime";
    private static final String PROP_VERBOSE = "verbose";
    
    
    // No constructor please!
    
    protected void initialize() {
        super.initialize();
    }
    
    public String displayName() {
        return NbBundle.getMessage(PepaSettings.class, "PEPA_settings");
    }
    
    
    public HelpCtx getHelpCtx() {
        return HelpCtx.DEFAULT_HELP;
    }
    
    /** Default instance of this system option, for the convenience of associated classes. */
    public static PepaSettings getDefault() {
        return (PepaSettings)findObject(PepaSettings.class, true);
    }
    
    public int getSolver(){
        if ((Integer)getProperty(PROP_SOLVER)==null){
            this.putProperty(PROP_SOLVER, new Integer(2));
        }
        return ((Integer)getProperty(PROP_SOLVER)).intValue();
    }
    public void setSolver(int i){
        this.putProperty(PROP_SOLVER, new Integer(i));
    }
    
    
    public int getOutput(){
        if ((Integer)getProperty(PROP_OUTPUT)==null){
            this.putProperty(PROP_OUTPUT, new Integer(1));
        }
        return ((Integer)getProperty(PROP_OUTPUT)).intValue();
    }
    public void setOutput(int i){
        this.putProperty(PROP_OUTPUT, new Integer(i));
    }
    
    
    public int getBgrndtime(){
        if ((Integer)getProperty(PROP_BGRNDTIME)==null){
            this.putProperty(PROP_BGRNDTIME, new Integer(1000));
        }
        return ((Integer)getProperty(PROP_BGRNDTIME)).intValue();
    }
    public void setBgrndtime(int i){
        this.putProperty(PROP_BGRNDTIME, new Integer(i));
    }
    
    public boolean isBackgrnd(){
        if((Boolean)getProperty(PROP_BACKGRND) ==null){
            this.putProperty(PROP_BACKGRND, new Boolean(true));
        }
        return ((Boolean)getProperty(PROP_BACKGRND)).booleanValue();
        
    }
    public void setBackgrnd(boolean b){
        putProperty(PROP_BACKGRND, b ? Boolean.TRUE : Boolean.FALSE);
        
    }
    
    public boolean isVerbose(){
                if((Boolean)getProperty(PROP_VERBOSE) ==null){
            this.putProperty(PROP_VERBOSE, new Boolean(false));
        }
        return ((Boolean)getProperty(PROP_VERBOSE)).booleanValue();        
    }
    
    public void setVerbose(boolean b){
        Reporter.get().setVerbose(b);        
        putProperty(PROP_VERBOSE, b ? Boolean.TRUE : Boolean.FALSE);
    }
    
    
    
    
    
    
    
    
    
}
