package eduni.inf.nbmodules.xmi.actions;

import eduni.inf.nbmodules.xmi.cookies.CollaborationCookie;
import eduni.inf.nbmodules.xmi.cookies.SequenceCookie;
import eduni.inf.nbmodules.xmi.loaders.UmlDiagramNode;
import eduni.inf.nbmodules.xmi.loaders.XmiDataObject;
import eduni.inf.nbmodules.xmi.loaders.ZumlDataObject;
import eduni.inf.pepa.pepa.Peparoni;
import eduni.inf.pepa.reflector.Reflector;
import eduni.inf.pepa.workbench.Reporter;

import java.io.File;
import java.io.IOException;
import org.openide.ErrorManager;
import org.openide.cookies.EditorCookie;
import org.openide.filesystems.FileObject;
import org.openide.filesystems.FileUtil;
import org.openide.loaders.DataObject;
import org.openide.nodes.AbstractNode;
import org.openide.nodes.FilterNode;
import org.openide.nodes.Node;
import org.openide.util.HelpCtx;
import org.openide.util.NbBundle;
import org.openide.util.actions.CookieAction;


import org.openide.windows.IOProvider;
import org.openide.windows.InputOutput;



/** Action to extract a LySa model from an diagram within an XMI or ZUML file.
 *
 *
 * @author N.V.Haenel
 */
public class ExtractLysaDiagram extends ExtractLysaAction{
    
    private String diagramName;
    
    protected Class[] cookieClasses() {
        return new Class[] { SequenceCookie.class};
    }
    
    protected int mode() {
        return MODE_EXACTLY_ONE;
    }
    
    
    protected void performAction(Node[] nodes) {
        
        UmlDiagramNode n = (UmlDiagramNode)nodes[0].getCookie(UmlDiagramNode.class);
        DataObject dataObject =n.getDataObject();
        diagramName = n.getDiagramName();
        super.performExtraction(dataObject);
                                
    }
    
     public String getName() {
        return NbBundle.getMessage(ExtractLysaDiagram.class, "ExtractLysaDiagram");
    }
    
    protected String iconResource() {
        return null;
        //return "eduni/inf/nbmodules/xmi/actions/icons/ExtractLysaAction.gif";
    }
    
    protected boolean asynchronous(){
        return true;
    }
    
    public HelpCtx getHelpCtx() {
        return HelpCtx.DEFAULT_HELP;
    }
}