package eduni.inf.nbmodules.xmi.actions;

import eduni.inf.nbmodules.xmi.cookies.ActivityCookie;
import eduni.inf.nbmodules.xmi.cookies.CollaborationCookie;
import eduni.inf.nbmodules.xmi.loaders.UmlDiagramNode;
import eduni.inf.nbmodules.xmi.loaders.XmiDataObject;
import eduni.inf.nbmodules.xmi.loaders.ZumlDataObject;
import eduni.inf.pepa.net.extractor.PEPANet_Extractor;
import eduni.inf.pepa.pepa.Peparoni;
import eduni.inf.pepa.reflector.Reflector;
import eduni.inf.pepa.workbench.Reporter;

import java.io.File;
import java.io.IOException;
import org.openide.ErrorManager;
import org.openide.cookies.EditorCookie;
import org.openide.filesystems.FileObject;
import org.openide.filesystems.FileUtil;
import org.openide.loaders.DataObject;
import org.openide.nodes.Node;
import org.openide.util.HelpCtx;
import org.openide.util.NbBundle;
import org.openide.util.actions.CookieAction;


import org.openide.windows.IOProvider;
import org.openide.windows.InputOutput;



/** Action to extract a PEPA model from an XMI or ZUML file.
 *
 *
 * @author N.V.Haenel
 */
public class ExtractPepaNetDiagram extends ExtractPepaNetAction {
    
    private String diagramName;
    
    protected Class[] cookieClasses() {
        return new Class[] {ActivityCookie.class};
    }
    
    protected int mode() {
        return MODE_EXACTLY_ONE;
    }
    
    
    protected void performAction(Node[] nodes) {
        UmlDiagramNode n = (UmlDiagramNode)nodes[0].getCookie(UmlDiagramNode.class);
        DataObject dataObject =n.getDataObject();
        diagramName = n.getDiagramName();
	this.performExtraction(dataObject);
	                
    }
    
    protected File extract(PEPANet_Extractor e, File umlFile){
        return e.extractPepaNetDiagram(umlFile, diagramName);
    }
                
    public String getName() {
        return NbBundle.getMessage(ExtractPepaAction.class, "ExtractPepaNetDiagram");
    }
    
    protected String iconResource() {
        return null;
        //return "eduni/inf/nbmodules/xmi/actions/icons/ExtractPepaNetAction.gif";
    }
    
    protected boolean asynchronous(){
        return true;
    }
    
    public HelpCtx getHelpCtx() {
        return HelpCtx.DEFAULT_HELP;
    }
}
