package eduni.inf.nbmodules.xmi.actions;

import eduni.inf.nbmodules.xmi.loaders.ZumlDataObject;
import java.io.*;
import java.util.Enumeration;
import java.util.zip.ZipEntry;
import java.util.zip.ZipException;
import java.util.zip.ZipFile;
import org.openide.ErrorManager;
import org.openide.filesystems.FileUtil;
import org.openide.nodes.Node;
import org.openide.util.HelpCtx;
import org.openide.util.NbBundle;
import org.openide.util.actions.CookieAction;
import org.openide.windows.IOProvider;
import org.openide.windows.InputOutput;


/** Action to refresh the cach for .zuml archive files.
 *
 * @author N.V.Haenel
 */
public class RefreshZumlAction extends CookieAction {
    
    protected Class[] cookieClasses() {
        return new Class[] {ZumlDataObject.class};
    }
    
    protected int mode() {
        return MODE_EXACTLY_ONE;
    }
    
    protected void performAction(Node[] nodes) {
        ZumlDataObject zdo = (ZumlDataObject)nodes[0].getCookie(ZumlDataObject.class);
        zdo.resetZipStream();
        // get the io tab for LySa
        InputOutput io  = IOProvider.getDefault().getIO("XMI", false);
        io.setFocusTaken(true);
        try{
            io.getOut().reset();
            io.select();
            io.getOut().write(zdo.getPrimaryFile().getName() +" has been refreshed");
        }catch(IOException ioe ){
            ErrorManager.getDefault().notify(ErrorManager.EXCEPTION, ioe);                        
        }                        
    }
    
    public String getName() {
        return NbBundle.getMessage(UnzipZumlAction.class, "RefreshZumlAction");
    }
    
    protected String iconResource() {
        //return "eduni/inf/nbmodules/xmi/actions/icons/UnzipArchiveAction.gif";
        return null;
    }
    
    public HelpCtx getHelpCtx() {
        return HelpCtx.DEFAULT_HELP;
        // If you will provide context help then use:
        // return new HelpCtx(UnzipZumlAction.class);
    }
    
    protected boolean asynchronous() {
        return true;
    }
    
    
    
}
