package eduni.inf.nbmodules.xmi.loaders;

import java.awt.Image;
import java.beans.BeanInfo;
import java.beans.IntrospectionException;
import java.beans.Introspector;
import java.beans.SimpleBeanInfo;

import org.openide.ErrorManager;
import org.openide.util.Utilities;


/** Description of {@link ZumlDataLoader}.
 *
 * @author N.V.Haenel
 */
public class ZumlDataLoaderBeanInfo extends SimpleBeanInfo {
      
    public BeanInfo[] getAdditionalBeanInfo() {
        try {
            // I.e. MultiFileLoader.class or UniFileLoader.class.
            return new BeanInfo[] {Introspector.getBeanInfo(ZumlDataLoader.class.getSuperclass())};
        } catch (IntrospectionException ie) {
            ErrorManager.getDefault().notify(ie);
            return null;
        }
    }
    
    public Image getIcon(int type) {
        if (type == BeanInfo.ICON_COLOR_16x16 || type == BeanInfo.ICON_MONO_16x16) {
            return Utilities.loadImage("eduni/inf/nbmodules/xmi/resources/ZumlDataIcon.gif", true);
        } else {
            return Utilities.loadImage("eduni/inf/nbmodules/xmi/resources/XmiDataIcon32.gif", true);
        }
    }
    
}
