package eduni.inf.nbmodules.xmi.loaders;

import eduni.inf.nbmodules.xmi.editor.ZumlEditorSupport;
import java.beans.BeanInfo;
import javax.swing.Action;
import org.openide.actions.OpenAction;
import org.openide.cookies.EditorCookie;
import org.openide.loaders.DataNode;
import org.openide.nodes.AbstractNode;
import org.openide.nodes.Children;
import org.openide.util.HelpCtx;
import org.openide.util.actions.SystemAction;




/** Represents the XMI entry in a ZUML archive {@link ZumlDataObject}
 *
 * @author N.V.Haenel
 */
public class ZumlSecondaryNode extends AbstractNode {
            
    public ZumlSecondaryNode(ZumlDataObject zdo, String iconbase, String extension ,int mode, Children c){
        super(c);
        setIconBase(iconbase);        
        setDisplayName(zdo.getPrimaryFile().getName()+(DataNode.getShowFileExtensions() ? extension : ""));                        
        
        getCookieSet().add(new ZumlEditorSupport(zdo, mode, this.getIcon(BeanInfo.ICON_COLOR_16x16)));                
    }
    
    public ZumlSecondaryNode(ZumlDataObject zdo, String iconbase,String extension, int mode ) {
        this(zdo,iconbase,extension,mode,Children.LEAF);
    }
    
    
    public Action[] getActions(boolean b) {
        return new Action[] {
            (Action)SystemAction.get(OpenAction.class)
        };
    }
        
    public HelpCtx getHelpCtx() {
        return HelpCtx.DEFAULT_HELP;
    }
    
    public Action getPreferredAction(){
        return (Action)SystemAction.get(OpenAction.class);
    }
    
}