package eduni.inf.pepa.pepamodel;

import eduni.inf.nbmodules.pepa.editor.parser.PepaParser;
import eduni.inf.pepa.pepamodel.other.DerivativeSet;
import eduni.inf.pepa.pepamodel.statespace.StateSpaceExplorer;
import eduni.inf.pepa.pepamodel.visitors.DerivativeFinder;
import eduni.inf.pepa.pepamodel.visitors.ModelNormaliser;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.util.Iterator;
import java.util.List;



/** JUnit tests for <code>eduni.inf.pepa.pepamodel.*</code>. 
 */

public class PepaModelTester{
    public PepaModel model;
    public PepaModel normed;
    
    public PepaModelTester(){
    }
       
    public static void main(String[] args){         
        try{
        PepaModelTester pmt = new PepaModelTester();        
        PepaParser p = new PepaParser(new FileInputStream(new File(args[0])));
        p.parse();
        pmt.model = p.getModel();
        System.out.println(pmt.model);
        
        pmt.testNormaliser();        
        //pmt.testDerivativeFinder();
        //pmt.testStateSpaceExplorer();
        
        }catch(IOException e){
            e.printStackTrace(System.err);
        }
    }
    
    
    
    void testNormaliser(){
        ModelNormaliser mn = new ModelNormaliser();
        normed = mn.normaliseModel(this.model);
        System.out.println(normed);        
    }
    
    
    /*
    void testDerivativeFinder(){
        DerivativeFinder d = new DerivativeFinder();
        List derivs = d.findDerivatives(this.normed);
        for(Iterator i = derivs.iterator();i.hasNext();){
            DerivativeSet set = (DerivativeSet)i.next();
            System.out.println(set);
        }
    }
    
    void testStateSpaceExplorer(){
        StateSpaceExplorer ssp = new StateSpaceExplorer(this.model);
        ssp.exploreStateSpace();        
        System.out.println(ssp);
        
    }
    */
}
