package eduni.inf.pepa.pepamodel.other;

import eduni.inf.pepa.pepamodel.process.PepaVariable;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.NoSuchElementException;



/**
 *
 * @author  N.V.Haenel
 */
public class DerivativeSet {
    
    private ArrayList derivatives;
    
    /** Creates a new instance of DerivativeSet */
    public DerivativeSet() {
        derivatives = new ArrayList();
    }
    
    public boolean add(PepaDerivative d){
        return derivatives.add(d);
    }
    
    public Iterator iterator(){
        return derivatives.iterator();
    }
    public PepaDerivative get(int index){
        return (PepaDerivative)derivatives.get(index);
        
    }
    public String toString(){
        return derivatives.toString();
    }
    /**Tests if a derivative with a given variable as label exists
     *
     * @args v the variable we are looking for     
     */
    public boolean contains(PepaVariable v){
        boolean contains = false;
        for(Iterator i = derivatives.iterator();i.hasNext();){
            if((((PepaDerivative)i.next()).getDerivative().equals(v)))
            contains = true;
        }
        return contains;
    }
    
    public int indexOf(PepaVariable v){
        for(int i = 0; i<derivatives.size();i++){
            PepaDerivative current = this.get(i);
            if(((current).getDerivative().equals(v))){                                
                return i;                
            }
        }
        throw new NoSuchElementException("Derivative "+v+" does not exist");
    }
           
}
