package eduni.inf.pepa.pepamodel.other;

/** Represents PEPA Action objects.
 *
 *
 * @author N.V.Haenel
 * @since 0.9.5
 *
 */

public class PepaAction implements Comparable{
    private String identifier;
    
    public PepaAction(String identifier){
        this.identifier = identifier;
    }
    
    public String getIdentifier(){
        return identifier;
    }
    
    public boolean equals(Object o){
        return o instanceof PepaAction && ((PepaAction)o).getIdentifier().equals(this.getIdentifier());
    }
     
    public int hashCode(){
        int result = 17;
        result = 37*result + identifier.hashCode();
        return result;
    }
    
    public String toString(){
        return identifier;
    }
    
    public int compareTo(Object obj) {
         // ClassCast excpetion throwen during cast
         return this.getIdentifier().compareTo(((PepaAction)obj).getIdentifier());
    }
    
}

