package eduni.inf.pepa.pepamodel.other;

import eduni.inf.pepa.pepamodel.rate.PepaRate;

/** Represents PEPA Activity objects
 *
 *
 * @author N.V.Haenel
 * @since 0.9.5
 *
 */
public class PepaActivity implements Comparable{
    private PepaAction action;
    private PepaRate rate;
    
    public PepaActivity(PepaAction action, PepaRate rate){
        this.action = action;
        this.rate = rate;
    }
    
    public PepaAction getAction(){
        return action;
    }
    
    public PepaRate getRate(){
        return rate;
    }
    
    public boolean equals(Object o){
        return o instanceof PepaActivity
        && ((PepaActivity)o).getAction().equals(this.getAction())
        && ((PepaActivity)o).getRate().equals(this.getRate());
    }
    
    public int hashCode(){
        int result = 17;
        result = 37*result + action.hashCode();
        result = 37*result + rate.hashCode();
        return result;
    }
    
    public String toString(){
        return "("+action.toString()+","+rate.toString()+")";
    }
    
    public int compareTo(Object obj){
        // class cast exception throws during cast
        int k;
        PepaActivity that = (PepaActivity)obj;
        if((k = this.getAction().compareTo(that.getAction()))!=0)
            return k;
        else
            return this.getRate().compareTo(that.getRate());
        
        
    }
    
}

