package eduni.inf.pepa.pepamodel.other;

import eduni.inf.pepa.pepamodel.process.PepaProcess;
import eduni.inf.pepa.pepamodel.process.PepaVariable;


/** Represents PEPA Definition objects.
 *
 * @author  N.V.Haenel
 * @since 0.9.5
 */
public class PepaDefinition {
    private PepaVariable variable;
    private PepaProcess definition;
        
    public PepaDefinition(PepaVariable variable, PepaProcess definition) {
        this.variable = variable;
        this.definition = definition;
    }
    
    public PepaVariable getVariable(){
        return this.variable;        
    }
    public PepaProcess getDefinition(){        
        return this.definition;
    }   
    
    public boolean equals (Object o){
        return o instanceof PepaDefinition
            && (this.getVariable().equals(((PepaDefinition)o).getVariable()))
            && (this.getDefinition().equals(((PepaDefinition)o).getDefinition()));
    }
    public String toString(){
        return new String(variable.toString()+" = "+definition.toString());
    }
}
