package eduni.inf.pepa.pepamodel.process;

import eduni.inf.pepa.pepamodel.other.ActionSet;
import eduni.inf.pepa.pepamodel.visitors.PepaProcessVisitor;



/** Represents PEPA Hide objects */
public class PepaHide extends PepaProcess implements PepaProcessVisitable{
    private PepaProcess process;
    private ActionSet hideSet;
    
    
    public PepaHide(PepaProcess process, ActionSet hideSet){
        this.process = process;
        this.hideSet = hideSet;
    }
    
    public void accept(PepaProcessVisitor visitor){
        visitor.visit(this);
    }
    
    public PepaProcess getProcess(){
        return process;
    }
    
    public ActionSet getHideSet(){
        return hideSet;
    }
    
    public boolean equals(Object o){
        return o instanceof PepaHide
        && process.equals(((PepaHide)o).getProcess())
        && hideSet.equals(((PepaHide)o).getHideSet());
    }
    public int hashCode(){
        int result = 17;
        result = 37*result + process.hashCode();
        result = 37*result + hideSet.hashCode();
        return result;
    }
    
    public String toString(){
        // curly braces inserted by hideSets toString method
        return "("+process.toString()+"/"+hideSet.toString()+")";
    }
    
    public int compareTo(Object o) {
        if(o instanceof PepaHide){
            PepaHide that = (PepaHide)o;
            int k;
            if((k= this.getProcess().compareTo(that.getProcess()))!=0)
                return k;
            else
                return this.getHideSet().compareTo(that.getHideSet());
        }
        return super.compareTo(o);
    }
}
