package eduni.inf.pepa.pepamodel.process;

import eduni.inf.pepa.pepamodel.other.PepaActivity;
import eduni.inf.pepa.pepamodel.visitors.PepaProcessVisitor;

/** Represents PEPA Prefix objects.*/
public class PepaPrefix extends PepaProcess implements PepaProcessVisitable{
    private PepaActivity activity;
    private PepaProcess process;
    
    public PepaPrefix(PepaActivity activity, PepaProcess process){
        this.activity = activity;
        this.process = process;
    }
    
    public void accept(PepaProcessVisitor visitor) {        
        visitor.visit(this);       
    }
    
    public PepaActivity getActivity(){
        return activity;
    }
    
    public PepaProcess getProcess(){
        return process;
    }
    
    public boolean equals(Object o){
        return o instanceof PepaPrefix
        && this.process.equals(((PepaPrefix)o).getProcess())
        && this.activity.equals(((PepaPrefix)o).getActivity());        
    }
    public int hashCode(){
        int result = 17;
        result = 37*result + activity.hashCode();
        result = 37*result + process.hashCode();
        return result;
    }
    
    public String toString(){
        return "("+activity.toString()+"."+process.toString()+")";
    }
    
   
    public int compareTo(Object o) {                  
        if(o instanceof PepaPrefix){
            int k;
            if((k = this.getProcess().compareTo(((PepaPrefix)o).getProcess())) != 0)
                return k;
            else 
                return this.getActivity().compareTo(((PepaPrefix)o).getActivity());
            
        }else            
            return super.compareTo(o);
   
    }
    
}

