package eduni.inf.pepa.pepamodel.process;

import eduni.inf.pepa.pepamodel.visitors.PepaProcessVisitor;

/** Represents PEPA Variable objcts.
 *
 * @author N.V.Haenel
 * @since 0.9.5
 *
 */
public class PepaVariable extends PepaProcess {
        
    /** The value of the variable */
    private String identifier;

    /* Standard constructor */
    public PepaVariable(String identifier){
        this.identifier = identifier;
    }
            
    public void accept(PepaProcessVisitor visitor) {
        visitor.visit(this);
    }
    
    /** Standard accessor method */
    public String getIdentifier(){
        return identifier;
    }
    
    public boolean equals(Object o){
        return o instanceof PepaVariable
        && identifier.equals(((PepaVariable)o).getIdentifier());
    }
    public int hashCode(){
        return 37*17 + identifier.hashCode();        
    }
    public String toString(){
        return "("+identifier+")";
    }

    /** Provides direct comparison of <code>PepaVariable</code> objects.
     *
     *  <p> Note that this method will not throw a <code>ClassCastException</code>
     *      when comparing to objects not of type <code>PepaVariable</code>
     *      but instead invoke the superclass method of <code>{@link PepaProcess}</code>.
     *  </p>
     *
     */
    public int compareTo(Object o) {
        if(o instanceof PepaVariable)
            return this.getIdentifier().compareTo(((PepaVariable)o).getIdentifier());
        else            
            return super.compareTo(o);
    }    
}

