package eduni.inf.pepa.pepamodel.rate;

/** Represents a PEPA rate that is a number. 
 *
 *
 *
 * @author  N.V.Haenel
 * @since 0.9.5
 */

public class PepaNumericRate extends PepaRate{
    private double value;
    
    public PepaNumericRate(double value){
        this.value = value;
    }
    
    public double getValue(){
        return value;
    }
    
    public double evaluate() {
        return value;
    }
    
    public int hashCode(){
        int result = 17;
        long temp = Double.doubleToLongBits(value);
        result = 37*result + (int)(temp ^ (temp>>>32));
        return result;
    }
    
    public String toString(){
        return "("+Double.toString(value)+")";
    }
    
    public boolean equals(Object o){
        return o instanceof PepaNumericRate 
        && ((PepaNumericRate)o).getValue() == this.getValue();
    }
    
    public int compareTo(Object o){
        if(o instanceof PepaNumericRate)
            return Double.compare(this.getValue(),((PepaNumericRate)o).getValue());
        else
            return super.compareTo(o);            
    }    
}

