package eduni.inf.pepa.pepamodel.rate;


/** Represents PEPA rates that are specified by a rate definition 
 *
 *
 *
 * @author  N.V.Haenel
 * @since 0.9.5
 */

 public class PepaSpecifiedRate extends PepaRate{
    private String identifier;
    private PepaRate rate;
    
    public PepaSpecifiedRate(String identifier, PepaRate rate){
        this.identifier = identifier;
        this.rate = rate;
    }
    
    public String getIdentifier(){
        return this.identifier;
    }
    
    public PepaRate getRate(){
        return this.rate;
    }
    
    public double evaluate(){
        return rate.evaluate();
    }
    
    public int hashCode(){
        int result = 17;
        result = 37*result + identifier.hashCode();
        result = 37*result + rate.hashCode();
        
        return result;
    }
    
    public String toString(){
        return "("+identifier+" = "+rate.toString()+")";
    }
    
    public boolean equals(Object o){
        return o instanceof PepaSpecifiedRate
        && ((PepaSpecifiedRate)o).getIdentifier().equals(this.getIdentifier())
        && ((PepaSpecifiedRate)o).getRate().equals(this.getRate());
    }
    
    public int compareTo(Object o){
        if(o instanceof PepaSpecifiedRate){
            int k;
            if((k = this.getIdentifier().compareTo(((PepaSpecifiedRate)o).getIdentifier()))!=0)
                return k;
            else
                return this.getRate().compareTo(((PepaSpecifiedRate)o).getRate());              
        }else
            return super.compareTo(o);
    }
}

