package eduni.inf.pepa.pepamodel.rate;

/** Represents the reserved rate TOP or <b>infty</b>. 
 *
 * @author  N.V.Haenel
 * @since 0.9.5
 */

 
public class PepaTopRate extends PepaRate{
    
    private static final PepaTopRate INSTANCE = new PepaTopRate();
    
    private PepaTopRate(){
    }
    
    public static PepaTopRate getTop(){
        return INSTANCE;
    }
    
    public double evaluate(){
        return -1;
    }
    
    public int hashCode(){
        return 0;
    }
    
    public String toString(){
        return "(infty)";
    }
    
    public boolean equals(Object o){
        return o == INSTANCE;        
    }
    
    public int compareTo(Object o){
        return super.compareTo(o);
    }
}

