package eduni.inf.pepa.pepamodel.statespace;

import eduni.inf.pepa.pepamodel.other.ActionSet;
import eduni.inf.pepa.pepamodel.other.DerivativeSet;
import eduni.inf.pepa.pepamodel.other.PepaDerivative;


/** This is a leaf of the state space explorer tree.
 *
 * @author  N.V.Haenel
 */
public class ExplorerLeaf implements ExplorerComponent{
    private DerivativeSet derivativeSet;           
    private int current;
    private int index;
    /** Creates a new instance of GeneratorLeaf */
    public ExplorerLeaf(DerivativeSet derivativeSet, int current, int index) {
        this.derivativeSet = derivativeSet;
        this.current = current;
        this.index = index;
    }
    public ActionSet getEnabledActions(){
        return new ActionSet(derivativeSet.get(current).getActionTypes());
    
    }
    
    public int getCurrentIndex(){
        return current;
    }
    
    public PepaDerivative getCurrent(){
        return (PepaDerivative)derivativeSet.get(current);        
    }
    
    public void setCurrent(int current){
        this.current = current;
    }
    public DerivativeSet getDerivativeSet(){
        return derivativeSet;
    }
    
    public int getIndex(){
        return index;
    }
    
    public void acceptExplorerVisitor(ExplorerVisitor visitor) {
    }
    
    public String toString(){
        return derivativeSet.get(current).getDerivative().getIdentifier();
    }
    
    
    public void setEnabledActions() {
        // implementation empty, 
    }
    
}
