package eduni.inf.pepa.pepamodel.statespace;

import eduni.inf.pepa.pepamodel.other.ActionSet;

/** This is a node in the state space explorer tree.
 *
 * @author  N.V.Haenel
 */
public class ExplorerNode implements ExplorerComponent{
    private ExplorerComponent left;
    private ExplorerComponent right;
    private ActionSet enabled;
    private ActionSet cooperationSet;
    
    
    /** Creates a new instance of GeneratorNode */
    public ExplorerNode(ExplorerComponent left, ExplorerComponent right, ActionSet cooperationSet) {
        this.left = left;
        this.right = right;
        this.cooperationSet = cooperationSet;
        
    }
    
    public void acceptExplorerVisitor(ExplorerVisitor visitor) {
    }
    
    public ActionSet getEnabledActions() {
        return enabled;       
    }
    
    public ActionSet getCooperationSet(){
        return this.cooperationSet;
    }
    
    public ExplorerComponent getLeft(){
        return this.left;
    }
    public ExplorerComponent getRight(){
        return this.right;
    }
    
    public String toString(){
        return "("+left.toString()+"<"+enabled.toString()+">"+right.toString()+")";
    }
    
    public void setEnabledActions() {
        left.setEnabledActions();
        right.setEnabledActions();
        ActionSet A = left.getEnabledActions();
        ActionSet B = right.getEnabledActions();
        ActionSet L = this.cooperationSet;
        enabled = ActionSet.difference(A,L);
        enabled = ActionSet.union(enabled , ActionSet.difference(B,L));
        enabled = ActionSet.union(enabled ,  ActionSet.intersection(ActionSet.intersection(A,B),L));        
    }
    
}
